<template>
  <section id="app" :class="[
    { dev },
    ( dev ? mode : undefined ),
    { mobile  :  portraitNotLandscape && !websiteGeneration },
    { desktop : !portraitNotLandscape && !websiteGeneration },
  ]">
    <div class="vlue-website" v-if="Object.keys(website).length">
      <container
        v-for="layer in ['base', 'fixed']"
        :class="[
          { 'vlue-base-layer-container'  :               'base' == layer },
          { 'vlue-fixed-layer-container' :              'fixed' == layer },
          { 'vlue-selected-layer'        :        selectedLayer == layer },
          { 'vlue-selected-area'         : editFrame || 'fixed' == layer },
        ]"
        v-show="layerVisibility[layer]"
        :style="getTopContainerStyle(layer)"
        :props="website[layer + 'LayerContainer']"
        :index="0"
        :key="layer"
      ></container>
      <mobile-menu></mobile-menu>
    </div>
    <sidebar v-if="!websiteGeneration"></sidebar>
    <image-select v-if="!websiteGeneration"></image-select>
    <font-select v-if="!websiteGeneration"></font-select>
    <create-popup v-if="Object.keys(createPopupParams).length"></create-popup>
    <error-message v-if="errorMessage"></error-message>
  </section>
</template>

<script lang="ts">
import Vue from 'vue'
import sidebar from '../dev/Sidebar.vue'
import createPopup from '../dev/CreatePopup.vue'
import imageSelect from '../dev/ImageSelect.vue'
import fontSelect from '../dev/FontSelect.vue'
import container from '../containers/Container.vue'
import mobileMenu from '../mobile/MobileMenu.vue'
import errorMessage from '../dev/ErrorMessage.vue'
import $ from 'jquery'
import store from '../../store/store'
import { mapState } from 'vuex'

export default Vue.extend({
  computed: {
    ...mapState([
      'dev',
      'mode',
      'website',
      'websiteHistoryUndo',
      'websiteHistoryRedo',
      'createPopupParams',
      'layerVisibility',
      'selectedLayer',
      'editFrame',
      'viewportWidth',
      'websiteGeneration',
      'errorMessage',
      'portraitNotLandscape',
    ])
  },
  components: {
    sidebar,
    createPopup,
    imageSelect,
    fontSelect,
    container,
    mobileMenu,
    errorMessage,
  },
  methods: {
    getTopContainerStyle(layer) {
      // object to store style attributes
      let style = {
        'width'     : undefined as string | undefined,
        'margin-top': undefined as string | undefined,
        'background': undefined as string | undefined,
      };
      // special styling applied to fixed layer container
      if (layer == 'fixed') {
        style = {
          // typescript checking
          width: undefined,
          // if base layer is visible, prevent fixed layer from extending beyond base layer
          'margin-top': this.layerVisibility.base ? '-100vh' : '0',
          // if base layer is not visible, add transparent black background to fixed layer
          'background': this.layerVisibility.base ? 'transparent' : 'rgba(0,0,0,0.25)',
        };
      }
      // set width based on development viewport width property
      style.width = this.viewportWidth;
      // return style attributes
      return style;
    },
  },
  created() {
    const self = this;
    $(document).keyup(function(e: any) {
      // don't trigger hotkey actions when typing into a text field
      if (!e.target.type || !e.target.type.includes('text')) {
        switch (e.key) {
          // hotkey actions
          case 'd': store.commit("toggleDev");                                              break;
          case 'z': if (self.dev && self.websiteHistoryUndo.length) store.dispatch("undo"); break;
          case 'y': if (self.dev && self.websiteHistoryRedo.length) store.dispatch("redo"); break;
        }
      }
    });
  }
})
</script>

<style lang="scss">
  @import "../../style/vars.scss";

  #app.mobile {
    .hide-on-mobile {
      display: none;
    }
  }

  #app.desktop {
    .hide-on-desktop {
      display: none;
    }
  }

  * {
    margin: 0;
    padding: 0;
    font-family: 'Abel-Pro';
  }
  p, h1, h2, h3, h4, h5, h6 {
    color: white;
    padding: 10px;
  }
  :focus {
    outline: none;
  }
  html {
    overflow-y: scroll;
    #app {
      min-height: 100vh;
      background-color: $vlue-outside-website-bg-color;
      background-image: url('../../../public/core/images/stripePattern.png');
      background-size: 30px;
      .vlue-website {
        vertical-align: top;
        position: relative;
        .vlue-base-layer-container {
          background: $vlue-website-default-bg-color;
          min-height: 100vh;
        }
        .vlue-fixed-layer-container {
          position: sticky;
          bottom: 0;
          width: inherit;
          height: 100vh;
        }
      }
      &.dev .vlue-website {
        width: calc(100vw - #{$vlue-dev-sidebar-width});
        .vlue-base-layer-container,
        .vlue-fixed-layer-container {
          &:not(.vlue-selected-layer) {
            pointer-events: none;
          }
        }
      }
    }
  }
</style>
